<template>
  <div>
    <base-dialog :show="!!error" title="An error occurred!" @close="handleError">
      <p>{{ error }}</p>
    </base-dialog>
    <section>
      <service-filter @change-filter="setFilters"></service-filter>
    </section>
    <section>
        <base-card>
          <div class="controls mb-3 ">
            <base-button mode="outline" @click="loadServices(true)">Rafraîchir</base-button>
            <router-link  v-if="!isService && !isLoading" link to="/services/ajouter" class="btn btn-outline-dark">Ajouter un service</router-link>
          </div>
          <div v-if="isLoading">
            <base-spinner></base-spinner>
          </div>
          <div v-else-if="hasServices">
            <div class="row row-cols-1 row-cols-md-3 g-4">

                    <service-item
                        v-for="service in filteredServices"
                        :key="service.id"
                        :id="service.id"
                        :name="service.name"
                        :price="service.price"
                        :provider="service.provider"
                        :category="service.category[0]"
                    ></service-item>

            </div>
          </div>
          <h3 v-else class="text-center">Aucun service n'as été trouvé.</h3>
        </base-card>
    </section>
   
  </div>
</template>

<script>
import ServiceItem from '../../components/services/ServiceItem.vue';
import ServiceFilter from '../../components/services/ServiceFilter.vue';

export default {
  components: {
    ServiceItem,
    ServiceFilter,
  },
  data() {
    return {
      isLoading: false,
      error: null,
      activeFilters: {
        inventore: true,
        officia: true,
        voluptas: true,
      },
    };
  },
  computed: {
    isService() {
      return this.$store.getters['services/isService'];
    },
    filteredServices() {
      const services = this.$store.getters['services/services'];
      console.log(services)
      return services.filter((service) => {
        return true;
        if (this.activeFilters.inventore && service.category.includes('inventore')) {
          console.log('inventore')
          return true;
        }
        if (this.activeFilters.inventore && service.category.includes('inventore')) {
          console.log('inventore')
          return true;
        }
        if (this.activeFilters.voluptas && service.category.includes('voluptas')) {
          console.log('voluptas')
          return true;
        }
        return false;
      });
    },
    hasServices() {
      return !this.isLoading && this.$store.getters['services/hasServices'];
    },
  },
  created() {
    this.loadServices();
  },
  methods: {
    setFilters(updatedFilters) {
      this.activeFilters = updatedFilters;
    },
    async loadServices(refresh = false) {
      this.isLoading = true;
      try {
        await this.$store.dispatch('services/loadServices', {
          forceRefresh: refresh,
        });
        console.log('ok')
      } catch (error) {
        console.log('erreir')
        this.error = error.message || 'Something went wrong!';
      }
      this.isLoading = false;
    },
    handleError() {
      this.error = null;
    },
  },
};
</script>

<style scoped>
ul {
  list-style: none;
  margin: 0;
  padding: 0;
}

.controls {
  display: flex;
  justify-content: space-between;
}
</style>